import { ValueTransformer } from "typeorm";
export declare type Constructor<T = {}> = new (...args: any[]) => T;
export declare class BigintValueTransformer implements ValueTransformer {
    to(entityValue: number): number;
    from(databaseValue: string): number;
}
export declare function IdEntity<TId extends Constructor>(Id: TId): (abstract new (...args: any[]) => {
    id: number;
}) & TId;
export declare function StatusEntity<TStatus extends Constructor>(Status: TStatus): (abstract new (...args: any[]) => {
    status: boolean;
}) & TStatus;
export declare function TimeEntity<TBaseTime extends Constructor>(BaseTime: TBaseTime): (abstract new (...args: any[]) => {
    createdAt: Date;
    updatedAt: Date;
    deletedAt?: Date | null;
}) & TBaseTime;
export declare function UuidEntity<TUuid extends Constructor>(Uuid: TUuid): (abstract new (...args: any[]) => {
    id: string;
}) & TUuid;
export declare class EmptyEntity {
}
