"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EmptyEntity = exports.UuidEntity = exports.TimeEntity = exports.StatusEntity = exports.IdEntity = exports.BigintValueTransformer = void 0;
const typeorm_1 = require("typeorm");
class BigintValueTransformer {
    to(entityValue) {
        return entityValue;
    }
    from(databaseValue) {
        return parseInt(databaseValue, 10);
    }
}
exports.BigintValueTransformer = BigintValueTransformer;
function IdEntity(Id) {
    class AbstractEntity extends Id {
    }
    __decorate([
        (0, typeorm_1.Generated)("increment"),
        (0, typeorm_1.PrimaryColumn)({
            type: "bigint",
            transformer: new BigintValueTransformer(),
        }),
        __metadata("design:type", Number)
    ], AbstractEntity.prototype, "id", void 0);
    return AbstractEntity;
}
exports.IdEntity = IdEntity;
function StatusEntity(Status) {
    class AbstractEntity extends Status {
    }
    __decorate([
        (0, typeorm_1.Column)({ nullable: false, default: true }),
        __metadata("design:type", Boolean)
    ], AbstractEntity.prototype, "status", void 0);
    return AbstractEntity;
}
exports.StatusEntity = StatusEntity;
function TimeEntity(BaseTime) {
    class AbstractEntity extends BaseTime {
    }
    __decorate([
        (0, typeorm_1.CreateDateColumn)({ type: "timestamp" }),
        __metadata("design:type", Date)
    ], AbstractEntity.prototype, "createdAt", void 0);
    __decorate([
        (0, typeorm_1.UpdateDateColumn)({ type: "timestamp" }),
        __metadata("design:type", Date)
    ], AbstractEntity.prototype, "updatedAt", void 0);
    __decorate([
        (0, typeorm_1.Column)({ type: "timestamp", nullable: true }),
        __metadata("design:type", Date)
    ], AbstractEntity.prototype, "deletedAt", void 0);
    return AbstractEntity;
}
exports.TimeEntity = TimeEntity;
function UuidEntity(Uuid) {
    class AbstractEntity extends Uuid {
    }
    __decorate([
        (0, typeorm_1.PrimaryGeneratedColumn)("uuid"),
        __metadata("design:type", String)
    ], AbstractEntity.prototype, "id", void 0);
    return AbstractEntity;
}
exports.UuidEntity = UuidEntity;
class EmptyEntity {
}
exports.EmptyEntity = EmptyEntity;
//# sourceMappingURL=entity.base.js.map