import { TypeOrmCrudService } from "@nestjsx/crud-typeorm";
import { DeepPartial, DeleteResult, EntityManager, EntityTarget, FindManyOptions, FindOneOptions, FindOperator, InsertResult, Repository, UpdateResult } from "typeorm";
export declare abstract class ServiceBase<Entity> extends TypeOrmCrudService<Entity> {
    protected repo: Repository<Entity>;
    constructor(repo: Repository<Entity>);
    get entity(): EntityTarget<Entity>;
    findOneBy(options?: FindOneOptions<Entity>, manager?: EntityManager): Promise<Entity>;
    findAllBy(options?: FindManyOptions<Entity>, manager?: EntityManager): Promise<Entity[]>;
    createOneBy(params: DeepPartial<Entity>, manager?: EntityManager): Promise<Entity>;
    createAllBy(params: DeepPartial<Entity>[], manager?: EntityManager): Promise<Entity[]>;
    createAllIfNotExistBy(params: DeepPartial<Entity>[], manager?: EntityManager): Promise<InsertResult>;
    createOrUpdateAllBy(params: DeepPartial<Entity>[], manager?: EntityManager): Promise<Entity[]>;
    updateOneBy(where: {
        [K in keyof Entity]?: any | FindOperator<Entity[K]>;
    }, set: {
        [K in keyof Entity]?: any;
    }, manager?: EntityManager): Promise<UpdateResult>;
    deleteOneBy(where?: {
        [K in keyof Entity]?: any | FindOperator<Entity[K]>;
    }, manager?: EntityManager): Promise<DeleteResult>;
}
