"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Farm = void 0;
const typeorm_1 = require("typeorm");
const entity_base_1 = require("../app/entity.base");
const protocol_entity_1 = require("../protocol/protocol.entity");
const token_entity_1 = require("../token/token.entity");
let Farm = class Farm extends (0, entity_base_1.IdEntity)((0, entity_base_1.TimeEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity))) {
};
Farm.relations = ["protocol", "stakeTokens", "rewardTokens"];
Farm.recursiveRelations = [
    "protocol.network",
    "stakeTokens.pair0",
    "stakeTokens.pair1",
    "rewardTokens.pair0",
    "rewardTokens.pair1",
];
__decorate([
    (0, typeorm_1.ManyToOne)(() => protocol_entity_1.Protocol, { nullable: false }),
    __metadata("design:type", protocol_entity_1.Protocol)
], Farm.prototype, "protocol", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "integer", nullable: false, default: 1 }),
    __metadata("design:type", Number)
], Farm.prototype, "group", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100 }),
    __metadata("design:type", String)
], Farm.prototype, "address", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Farm.prototype, "pid", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Farm.prototype, "poolAddress", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100 }),
    __metadata("design:type", String)
], Farm.prototype, "assets", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => token_entity_1.Token),
    (0, typeorm_1.JoinTable)({ name: "farm_stake_token" }),
    __metadata("design:type", Array)
], Farm.prototype, "stakeTokens", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => token_entity_1.Token),
    (0, typeorm_1.JoinTable)({ name: "farm_reward_token" }),
    __metadata("design:type", Array)
], Farm.prototype, "rewardTokens", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "json", nullable: true }),
    __metadata("design:type", Object)
], Farm.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Farm.prototype, "link", void 0);
Farm = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_farm_1", ["protocol", "address", "poolAddress", "pid"], {
        unique: true,
    })
], Farm);
exports.Farm = Farm;
//# sourceMappingURL=farm.entity.js.map