"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Interaction = void 0;
const typeorm_1 = require("typeorm");
const entity_base_1 = require("../app/entity.base");
const network_entity_1 = require("../network/network.entity");
const interaction_constant_1 = require("./interaction.constant");
const crypto = require("crypto");
let Interaction = class Interaction extends (0, entity_base_1.IdEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity)) {
    in_() {
        this._ = crypto
            .createHash("sha256")
            .update(`${this.network.id}${this.type}${this.contractAddress}${this.address}${this.referPid}${this.referAddress}`)
            .digest("hex");
    }
};
Interaction.relations = ["network"];
Interaction.recursiveRelations = [];
__decorate([
    (0, typeorm_1.ManyToOne)(() => network_entity_1.Network, { nullable: false }),
    __metadata("design:type", network_entity_1.Network)
], Interaction.prototype, "network", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "enum", enum: interaction_constant_1.INTERACTION_TYPE }),
    __metadata("design:type", String)
], Interaction.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100 }),
    __metadata("design:type", String)
], Interaction.prototype, "contractAddress", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100 }),
    __metadata("design:type", String)
], Interaction.prototype, "address", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Interaction.prototype, "referPid", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Interaction.prototype, "referAddress", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, unique: true }),
    __metadata("design:type", String)
], Interaction.prototype, "_", void 0);
__decorate([
    (0, typeorm_1.BeforeInsert)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], Interaction.prototype, "in_", null);
Interaction = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_interaction_1", ["address"], { unique: false })
], Interaction);
exports.Interaction = Interaction;
//# sourceMappingURL=interaction.entity.js.map