import { Interaction } from "./interaction.entity";
import { Repository } from "typeorm";
import { Network } from "../network/network.entity";
import { Token } from "../token/token.entity";
import { Farm } from "../farm/farm.entity";
import { Lending } from "../lending/lending.entity";
import { NFToken } from "../nf-token/nf-token.entity";
import { ServiceBase } from "../app/service.base";
export declare class InteractionService extends ServiceBase<Interaction> {
    readonly repo: Repository<Interaction>;
    constructor(repo: Repository<Interaction>);
    getTokenInteractions(address: string, network?: Network): Promise<Token[]>;
    getFarmInteractions(address: string, network: Network): Promise<Farm[]>;
    getLendingInteractions(address: string, network: Network): Promise<Lending[]>;
    getERC721NFTokenInteractions(address: string, network: Network): Promise<NFToken[]>;
    getERC1155NFTokenInteractions(address: string, network: Network): Promise<NFToken[]>;
}
