"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Lending = void 0;
const typeorm_1 = require("typeorm");
const token_entity_1 = require("../token/token.entity");
const protocol_entity_1 = require("../protocol/protocol.entity");
const entity_base_1 = require("../app/entity.base");
let Lending = class Lending extends (0, entity_base_1.IdEntity)((0, entity_base_1.TimeEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity))) {
};
Lending.relations = ["protocol", "supplyTokens", "borrowTokens"];
Lending.recursiveRelations = [
    "protocol.network",
    "supplyTokens.pair0",
    "supplyTokens.pair1",
    "borrowTokens.pair0",
    "borrowTokens.pair1",
];
__decorate([
    (0, typeorm_1.ManyToOne)(() => protocol_entity_1.Protocol, {
        nullable: false,
    }),
    __metadata("design:type", protocol_entity_1.Protocol)
], Lending.prototype, "protocol", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "integer", nullable: false, default: 1 }),
    __metadata("design:type", Number)
], Lending.prototype, "group", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 50 }),
    __metadata("design:type", String)
], Lending.prototype, "assets", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => token_entity_1.Token),
    (0, typeorm_1.JoinTable)({ name: "lending_supply_token" }),
    __metadata("design:type", Array)
], Lending.prototype, "supplyTokens", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => token_entity_1.Token),
    (0, typeorm_1.JoinTable)({ name: "lending_borrow_token" }),
    __metadata("design:type", Array)
], Lending.prototype, "borrowTokens", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: true }),
    __metadata("design:type", String)
], Lending.prototype, "address", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Lending.prototype, "pid", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false, default: "" }),
    __metadata("design:type", String)
], Lending.prototype, "marketAddress", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "json", nullable: true }),
    __metadata("design:type", Object)
], Lending.prototype, "data", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Lending.prototype, "link", void 0);
Lending = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_lending_1", ["protocol", "address", "marketAddress", "pid"], {
        unique: true,
    })
], Lending);
exports.Lending = Lending;
//# sourceMappingURL=lending.entity.js.map