"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Network = void 0;
const typeorm_1 = require("typeorm");
const entity_base_1 = require("../app/entity.base");
const network_constant_1 = require("./network.constant");
let Network = class Network extends (0, entity_base_1.IdEntity)((0, entity_base_1.TimeEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity))) {
    get chainKey() {
        return `${this.chainType}-${this.chainId}`;
    }
};
Network.relations = [];
Network.recursiveRelations = [];
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 50, nullable: false }),
    __metadata("design:type", String)
], Network.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 50, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "subName", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 50, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "slug", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 50, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "currencySymbol", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: "enum",
        enum: network_constant_1.NETWORK_CHAIN_TYPE,
    }),
    __metadata("design:type", String)
], Network.prototype, "chainType", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: "enum",
        enum: network_constant_1.NETWORK_CHAIN_ID,
    }),
    __metadata("design:type", String)
], Network.prototype, "chainId", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "multiCallAddress", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "json" }),
    __metadata("design:type", Object)
], Network.prototype, "http", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "integer", nullable: true }),
    __metadata("design:type", Number)
], Network.prototype, "blockTimeSec", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "explorerUrl", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Network.prototype, "logoLink", void 0);
Network = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_network_1", ["chainType", "chainId"], { unique: true })
], Network);
exports.Network = Network;
//# sourceMappingURL=network.entity.js.map