import { Network } from "./network.entity";
import { TAggregatorProvider, TAggregatorProviders } from "./network.interface";
import { INetworkProviderHealthCheck } from "./network.interface";
import { Repository } from "typeorm";
import { ServiceBase } from "../app/service.base";
export declare class NetworkService extends ServiceBase<Network> {
    readonly repo: Repository<Network>;
    private _networkWithProviderByChainKey;
    constructor(repo: Repository<Network>);
    onModuleInit(): Promise<void>;
    provider(chainKey: string): TAggregatorProvider;
    providers(chainKey: string): TAggregatorProviders;
    refreshNetwork(network?: Network): Promise<void>;
    multiCallAddress(chainKey: string): string;
    generateNetworkProviders(network: Network): TAggregatorProviders;
    checkProviderHealth(network?: Network): Promise<INetworkProviderHealthCheck>;
}
