"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Protocol = void 0;
const typeorm_1 = require("typeorm");
const entity_base_1 = require("../app/entity.base");
const network_entity_1 = require("../network/network.entity");
const token_entity_1 = require("../token/token.entity");
const protocol_constant_1 = require("./protocol.constant");
let Protocol = class Protocol extends (0, entity_base_1.IdEntity)((0, entity_base_1.TimeEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity))) {
};
Protocol.relations = ["network", "token"];
Protocol.recursiveRelations = [];
__decorate([
    (0, typeorm_1.ManyToOne)(() => network_entity_1.Network, { nullable: false }),
    __metadata("design:type", network_entity_1.Network)
], Protocol.prototype, "network", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "enum", enum: protocol_constant_1.PROTOCOL_NAME }),
    __metadata("design:type", String)
], Protocol.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => token_entity_1.Token, { nullable: true }),
    (0, typeorm_1.JoinColumn)(),
    __metadata("design:type", token_entity_1.Token)
], Protocol.prototype, "token", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Protocol.prototype, "useFarm", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Protocol.prototype, "useLending", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Protocol.prototype, "useInteraction", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Protocol.prototype, "link", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 500, nullable: true }),
    __metadata("design:type", String)
], Protocol.prototype, "logoLink", void 0);
Protocol = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_protocol_1", ["network", "name"], { unique: true })
], Protocol);
exports.Protocol = Protocol;
//# sourceMappingURL=protocol.entity.js.map