import { EmptyEntity } from "../app/entity.base";
import { TOKEN_TYPE } from "./token.constant";
import { Network } from "../network/network.entity";
import { TokenCoinMarketCapData } from "../token-coin-market-cap-data/token-coin-market-cap-data.entity";
import { TokenCoinGeckoData } from "../token-coin-gecko-data/token-coin-gecko-data.entity";
import { CentralExchangeMarket } from "../central-exchange-market/central-exchange-market.entity";
declare const Token_base: (abstract new (...args: any[]) => {
    id: number;
}) & (abstract new (...args: any[]) => {
    createdAt: Date;
    updatedAt: Date;
    deletedAt?: Date;
}) & (abstract new (...args: any[]) => {
    status: boolean;
}) & typeof EmptyEntity;
export declare class Token extends Token_base {
    network: Network;
    type: TOKEN_TYPE;
    name: string;
    symbol: string;
    address: string;
    decimals: number;
    totalSupply: string;
    pair0: Token;
    pair1: Token;
    swapBase: boolean;
    verify: boolean;
    isStable: boolean;
    wrapped: Token;
    coinMarketCap: TokenCoinMarketCapData;
    coinGecko: TokenCoinGeckoData;
    centralExchangeMarkets: CentralExchangeMarket[];
    ntsCode: string;
    static relations: string[];
    static recursiveRelations: string[];
}
export {};
