"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var Token_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Token = void 0;
const typeorm_1 = require("typeorm");
const entity_base_1 = require("../app/entity.base");
const token_constant_1 = require("./token.constant");
const network_entity_1 = require("../network/network.entity");
const token_coin_market_cap_data_entity_1 = require("../token-coin-market-cap-data/token-coin-market-cap-data.entity");
const token_coin_gecko_data_entity_1 = require("../token-coin-gecko-data/token-coin-gecko-data.entity");
const central_exchange_market_entity_1 = require("../central-exchange-market/central-exchange-market.entity");
let Token = Token_1 = class Token extends (0, entity_base_1.IdEntity)((0, entity_base_1.TimeEntity)((0, entity_base_1.StatusEntity)(entity_base_1.EmptyEntity))) {
};
Token.relations = [
    "network",
    "coinMarketCap",
    "coinGecko",
    "centralExchangeMarkets",
];
Token.recursiveRelations = [
    "coinMarketCap.history",
    "coinGecko.history",
    "centralExchangeMarkets.centralExchange",
    "centralExchangeMarkets.quote",
];
__decorate([
    (0, typeorm_1.ManyToOne)(() => network_entity_1.Network, { nullable: false }),
    __metadata("design:type", network_entity_1.Network)
], Token.prototype, "network", void 0);
__decorate([
    (0, typeorm_1.Column)({
        type: "enum",
        enum: token_constant_1.TOKEN_TYPE,
    }),
    __metadata("design:type", String)
], Token.prototype, "type", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false }),
    __metadata("design:type", String)
], Token.prototype, "name", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false }),
    __metadata("design:type", String)
], Token.prototype, "symbol", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: false }),
    __metadata("design:type", String)
], Token.prototype, "address", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "integer", nullable: false }),
    __metadata("design:type", Number)
], Token.prototype, "decimals", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "decimal", precision: 65, scale: 22, default: 0 }),
    __metadata("design:type", String)
], Token.prototype, "totalSupply", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => Token_1, (token) => token.pair0, {
        nullable: true,
        onDelete: "CASCADE",
    }),
    __metadata("design:type", Token)
], Token.prototype, "pair0", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => Token_1, (token) => token.pair1, {
        nullable: true,
        onDelete: "CASCADE",
    }),
    __metadata("design:type", Token)
], Token.prototype, "pair1", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Token.prototype, "swapBase", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Token.prototype, "verify", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "bool", default: false }),
    __metadata("design:type", Boolean)
], Token.prototype, "isStable", void 0);
__decorate([
    (0, typeorm_1.OneToOne)(() => Token_1, {
        nullable: true,
        onDelete: "CASCADE",
    }),
    (0, typeorm_1.JoinColumn)(),
    __metadata("design:type", Token)
], Token.prototype, "wrapped", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => token_coin_market_cap_data_entity_1.TokenCoinMarketCapData, (tokenCoinMarketCapData) => tokenCoinMarketCapData.id, {
        nullable: true,
        onDelete: "CASCADE",
    }),
    __metadata("design:type", token_coin_market_cap_data_entity_1.TokenCoinMarketCapData)
], Token.prototype, "coinMarketCap", void 0);
__decorate([
    (0, typeorm_1.ManyToOne)(() => token_coin_gecko_data_entity_1.TokenCoinGeckoData, (tokenCoinGeckoData) => tokenCoinGeckoData.id, {
        nullable: true,
        onDelete: "CASCADE",
    }),
    __metadata("design:type", token_coin_gecko_data_entity_1.TokenCoinGeckoData)
], Token.prototype, "coinGecko", void 0);
__decorate([
    (0, typeorm_1.ManyToMany)(() => central_exchange_market_entity_1.CentralExchangeMarket),
    (0, typeorm_1.JoinTable)({ name: "token_market" }),
    __metadata("design:type", Array)
], Token.prototype, "centralExchangeMarkets", void 0);
__decorate([
    (0, typeorm_1.Column)({ type: "varchar", length: 100, nullable: true }),
    __metadata("design:type", String)
], Token.prototype, "ntsCode", void 0);
Token = Token_1 = __decorate([
    (0, typeorm_1.Entity)(),
    (0, typeorm_1.Index)("idx_token_1", ["network", "address"], { unique: true })
], Token);
exports.Token = Token;
//# sourceMappingURL=token.entity.js.map